Package org.apache.tapestry5.ioc.internal

# Class ServiceDecoratorImpl

java.lang.Object
org.apache.tapestry5.ioc.internal.AbstractMethodInvokingInstrumenter
org.apache.tapestry5.ioc.internal.ServiceDecoratorImpl

All Implemented Interfaces:
  `ServiceDecorator`

public class ServiceDecoratorImpl extends AbstractMethodInvokingInstrumenter implements ServiceDecorator
A wrapper around a decorator method.

- ## Field Summary

  ### Fields inherited from class org.apache.tapestry5.ioc.internal.AbstractMethodInvokingInstrumenter

  `method, resourcesDefaults, serviceId, serviceInterface`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `ServiceDecoratorImpl(Method method, ModuleBuilderSource moduleSource, ServiceResources resources, PlasticProxyFactory proxyFactory)`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `Object`
  `createInterceptor(Object delegate)`
  Creates a new interceptor object implementing the same service interface as the delegate object.

  ### Methods inherited from class org.apache.tapestry5.ioc.internal.AbstractMethodInvokingInstrumenter

  `invoke, toString`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- ## Constructor Details

  - ### ServiceDecoratorImpl

    public ServiceDecoratorImpl(Method method, ModuleBuilderSource moduleSource, ServiceResources resources, PlasticProxyFactory proxyFactory)

- ## Method Details

  - ### createInterceptor

    public Object createInterceptor(Object delegate)
    Description copied from interface: `ServiceDecorator`
    Creates a new interceptor object implementing the same service interface as the delegate object.
    Specified by:
      `createInterceptor` in interface `ServiceDecorator`
    Parameters:
      `delegate` - an existing object implementing the service interface.
    Returns:
      a new object implementing the same service interface, or delegate or null if the decorator chooses not to create a new interceptor.